/**
 * Sortd
 * Copyright (c) 2019, Sortd Inc
 * https://www.sortd.com
 *
 * @fileoverview Contains config shared across all environments
 * @name config.common
 */

'use strict';

/**
 * Config definition.
 */

const configCommon = function () {

	const config = {};

	config.chrome = {};
	config.chrome.host = {};
	config.chrome.host.mail3 = {};
	config.chrome.csp = {};

	config.useRequire = false;
	config.emptyExtensionErrorInterval = 50;

	config.chrome.sortd = {
		emailSharingPermissionsURL: 'https://sortd.freshdesk.com/support/solutions/articles/6000219380-shared-email-more-info-',
		readReceiptPermissionsURL: 'https://sortd.freshdesk.com/solution/articles/6000196929-email-tracking-option-to-track-all-opens-except-your-own',
		readReceiptGdprURL: 'https://sortd.freshdesk.com/support/solutions/articles/6000197095-email-tracking-in-relation-to-eu-citizens-and-gdpr',
		supportURL: 'https://sortd.freshdesk.com/support/home',
		websiteURL: 'https://www.sortd.com',
		customizeListsURL: 'https://sortd.freshdesk.com/a/solutions/articles/6000224591?lang=en&portalId=6000027152',
		failedToLoadURL: 'https://sortd.freshdesk.com/a/solutions/articles/6000241622'
	};

	config.messageOriginGmail = 'https://mail.google.com';

	config.CSP = {
		hosts: [
			'https://*.google.com',
			'https://*.sortd.com',
			'https://*.getsidekick.com',
			'https://*.getsidekickqa.com',
			'https://*.mixmax.com',
			'https://d1j5o6e2vipffp.cloudfront.net/',
			'https://d14ym0a63kne8r.cloudfront.net/',
			'https://engine.kadira.io/simplentp/sync',
			'http://*.talkgadget.google.com',
			'https://use.typekit.net',
			'https://mailfoogae.appspot.com',
			'https://*.linkedin.com',
			'https://*.google-analytics.com',
			'https://*.hotjar.com',
			'https://www.inboxsdk.com/build/'
		],
		iframeHosts: [
			'https://*.sortd.com',
			'https://*.getsidekick.com',
			'https://*.getsidekickqa.com',
			'https://mailfoogae.appspot.com',
			'https://*.linkedin.com',
			'https://*.facebook.com',
			'https://*.twitter.com',
			'https://twitter.com',
			'https://*.yesware.com',
			'https://*.yetihut.com',
			'https://yesware-ka-ching.herokuapp.com',
			'https://yesware-ka-ching-dev.herokuapp.com',
			'https://yesware-account-completion.herokuapp.com',
			'https://yesware-account-completion-dev.herokuapp.com',
			'https://yesware-peacockosaurus-dev.herokuapp.com',
			'https://*.mixmax.com',
			'https://d1j5o6e2vipffp.cloudfront.net/',
			'https://d14ym0a63kne8r.cloudfront.net/',
			'https://engine.kadira.io/simplentp/sync',
			'https://*.google-analytics.com',
			'https://*.hotjar.com',
			'https://www.inboxsdk.com/build/'
		]
	};

	return config;
};