/**
 * Sortd
 * Copyright (c) 2019, Sortd Inc
 * https://www.sortd.com
 *
 * @fileoverview Provides a basic configuration object for server-side configuration settings.
 * @name Config
 */

'use strict';

/**
 * Config definition.
 */

const config = function (overrides) {

	const config = configCommon();

	config.version = '1.9.1.8214';
	config.ceType = overrides['ceType'] || 'Gmail';
	config.trackingOverrides = overrides['trackingOverrides'] || null;

	// Mail3 chrome extension config
	config.chrome.host.mail3.scheme = 'https';
	config.chrome.host.mail3.realm = 'app.sortd.com';
	config.chrome.host.mail3.port = '';
	config.chrome.host.mail3.baseUrl = config.chrome.host.mail3.scheme + '://' +
		config.chrome.host.mail3.realm;
	if (config.chrome.host.mail3.port !== '') {
		config.chrome.host.mail3.baseUrl += ':' + config.chrome.host.mail3.port;
	}
	config.chrome.host.mail3.assetsUrl = 'https://static.sortd.com';
	config.chrome.host.mail3.linkUrls = [
		config.chrome.host.mail3.baseUrl,
		config.chrome.host.mail3.baseUrl.replace(config.chrome.host.mail3.realm, 'stage.sortd.com')
	];

	// Usage tracking
	config.tracker = {
		googleanalytics: {
			name: 'googleanalytics',
			enabled: true,
			token: 'UA-60579077-1'
		},
		googletagmanager: {
			name: 'googletagmanager',
			enabled: true,
			token: 'AW-966631203',
			conversions: {
				installed_ce: 'AW-966631203/UP_bCKjW_H4Qo772zAM'
			}
		},
		facebook: {
			name: 'facebook',
			enabled: true,
			token: '827452130790680'
		}
	};

	return config;
};