/**
 * Sortd
 * Copyright (c) 2019, Sortd Inc
 * https://www.sortd.com
 *
 * @fileoverview Constants for the extension
 * @name constants
 */

/**
 * constants definition.
 */

var constants = (function () {

	'use strict';

	var _constants = {
		RETRY_DELAY: 1000,
		CHECK_SCRIPT_INTERVAL: 100,
		CHECK_SCRIPT_RETRIES: 100,
		DONT_LOAD_WHEN_WINDOW_LOC_CONTAINS: [

		],
		MONTHS: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
		PANEL_DISPLAY_MODES: {
			MINIMIZED: 'minimized',
			SIDEBAR: 'sidebar',
			FULLSCREEN: 'fullscreen',
			EMBEDDED: 'embedded'
		},
		MESSAGE_TIMEOUT: {
			TO_FRAME: 2000
		},
		RECIPIENT_TYPE: {
			TO: 'TO',
			CC: 'CC'
		},

		SHORTCUTS: {
			KEY_CODES: {
				ENTER: 13,
				ESCAPE: 27,
				SHIFT: 16,
				CTRL: 17,
				ALT: 18,
				META: 91,
				SPACE: 32,
				UP_ARROW: 38,
				DOWN_ARROW: 40,
				E: 69,
				S: 83,
				U: 85
			},
			FRAME_FOCUS: [
				27, 76, 86
			],
			ALLOWED_CODES: [
			//  bcksp tab enter arrows      windows/mac keys
				8    ,9  ,13   ,37,38,39,40,91,92,93,
			//	A  C  D  F  N  P  R  a  c  d   f   n   p   r
				65,67,68,70,78,80,82,97,99,100,102,110,112,114,
			//	f1  f2  f3  f4  f5  f6  f7  f8  f9  f10 f11 f12
				112,113,114,115,116,117,118,119,120,121,122,123
			]
		}
	};

	_constants.loader = {
		backgroundImgCount: 7,
		getEmail: {
			retries: 5,
			delayBetweenRetries: 100
		},
		emailContainer: '#loading .msg',
		emailRegex: '\\s*(\\S+@\\S+\\..*?)(…|\\.{3}|\\s).*',
		loadingContainer: '#loading .msgb',
		loaderMenuHtml: '<div class="sortdLoaderMenu">' +
				'<div class="sortdLoaderMenuItems">' +
					'<div data-sortd_menu="options">Options</div>' +
				'</div>' +
				'<div class="sortdLoaderOptionsMenu" data-sortd_menu_option="options">' +
					'<div class="sortdLoaderMenuArrow"><div></div></div>' +
					'<ul>' +
						'<li class="sortdOptionsMenuHeader">Start In:</li>' +
						'<li data-sortd_fullscreen="1">Sortd Mode</li>' +
						'<li data-sortd_fullscreen="0">Gmail Mode</li>' +
					'</ul>' +
				'</div>' +
				'<div class="sortdLoaderInfoMenu" data-sortd_menu_option="info" style="display: none;">' +
					'<div class="sortdLoaderMenuArrow"><div></div></div>' +
					'<div class="sortdInfoHeader">Info</div>' +
					'<div>Sortd is loading in parallel with Gmail.<br>' +
						'If you would like to load into the standard Gmail view instead of the Sortd view, select Settings within Sortd and change the default view mode.' +
					'</div>' +
				'</div>' +
			'</div>',
		sortdLoaderCreditsHtml:
		'<div class="sortdLoaderCreditsContainer">' +
		  '<div class="background-info">'+
			'<div class="title">CREDITS_BACKGROUND_INFO_TITLE</div>' +
			'<div class="source">'+
				'<a href="CREDITS_BACKGROUND_INFO_SOURCE_LINK" target="_blank" class="source-url">Photo by CREDITS_BACKGROUND_INFO_SOURCE_AUTHOR</a>' +
			'</div>' +
		  '</div>'+
		 '</div>',
		loaderMenuRememberHtml: '<div id="sortdLoaderRememberSetting">' +
				'<div>Do you want to remember this setting ' +
					'<div class="sortdRememberOption" data-sortd_save_setting="1">Yes</div>' +
					'<div class="sortdRememberOption" data-sortd_save_setting="0">No</div> ' +
				'</div>' +
			'</div>',
		loaderMenuCSS: '.sortdLoaderMenu {font-family: arial, sans-serif;font-size: 12px;position: fixed;top: 10px;right: 25px;width: 150px;display: inline-block; z-index: 2010;}' +
			'.sortdLoaderMenu .sortdLoaderMenuItems {text-align: right;}' +
			'.sortdLoaderMenu .sortdLoaderMenuItems > div {display: inline-block; margin-left:12px; vertical-align: middle; cursor: pointer; text-shadow: 0 0 7px rgba(0, 0, 0, 1);}' +
			'.sortdLoaderMenu .sortdLoaderOptionsMenu, .sortdLoaderMenu .sortdLoaderInfoMenu {box-shadow: 0px 2px 2px 0px rgba(0, 0, 0, 0.45);position: relative;top: 12px;color: #3f3f3f;background-color: #ffffff;border: 1px solid #8f8f8f;}' +
			'.sortdLoaderMenu .sortdLoaderMenuArrow {position: absolute;top: -10px;right: 11px;width: 0;height: 0;border-left: 10px solid transparent;border-bottom: 10px solid #8f8f8f;border-right: 10px solid transparent;z-index: 20;}' +
			'.sortdLoaderMenu .sortdLoaderMenuArrow > div {position: absolute;top: 2px;right: -9px;width: 0;height: 0;border-left: 9px solid transparent;border-bottom: 9px solid #ffffff;border-right: 9px solid transparent;z-index: 21;}' +
			'.sortdLoaderMenu .sortdLoaderInfoMenu {padding: 5px 5px 7px 9px;}' +
			'.sortdLoaderMenu .sortdLoaderInfoMenu .sortdInfoHeader {font-size: 11px;font-weight: bold;padding-bottom: 7px;}' +
			'.sortdLoaderMenu .sortdLoaderInfoMenu .sortdLoaderMenuArrow {right: 53px;}' +
			'.sortdLoaderMenu .sortdLoaderOptionsMenu ul {list-style: none;margin: 0;padding: 0;max-height: 165px;overflow-y: auto;}' +
			'.sortdLoaderMenu .sortdLoaderOptionsMenu ul li.sortdOptionsMenuHeader {font-size: 11px;font-weight: bold;padding: 5px 0 7px 9px;}' +
			'.sortdLoaderMenu .sortdLoaderOptionsMenu ul li:not(.sortdOptionsMenuHeader) {padding: 7px 0 7px 25px;cursor: pointer;}' +
			'.sortdLoaderMenu .sortdLoaderOptionsMenu ul li:not(.sortdOptionsMenuHeader):hover {font-weight: bold;}' +
			'.sortdLoaderMenu .sortdLoaderOptionsMenu ul li:not(.sortdOptionsMenuHeader).selected {background: url(TICK_ICON_URL) no-repeat 10px center;}' +
			'#sortdLoaderRememberSetting {display: none; font-family: arial, sans-serif;font-size: 12px;color: #3f3f3f; position:absolute; top: 10px; left: 0; right: 0; height: 0; z-index: 2025}' +
			'#sortdLoaderRememberSetting > div {background-color: #f9edbe; border: 1px solid #f0c36d; padding:5px 15px; width: 260px; margin: 0 auto;}' +
			'#sortdLoaderRememberSetting .sortdRememberOption {display: inline-block; color: royalblue; text-decoration: underline; cursor: pointer; margin: 0 5px; font-weight: bold;}'+
			'.sortdLoaderCreditsContainer { position: absolute; bottom: 20px; left: 20px;}'+
			'.sortdLoaderCreditsContainer .background-info { bottom: 0; display: inline-block; transition: all 0.2s ease; position: absolute;width: 250px;height: 35px; }' +
			'.sortdLoaderCreditsContainer .background-info .title, .sortdLoaderCreditsContainer .background-info .source { position: absolute; bottom: 0; left: 0; transition: all 0.3s ease-out; white-space: nowrap;}' +
			'.sortdLoaderCreditsContainer .background-info .title { opacity: 0.9; transition-delay: 0.15s; }'+
			'.sortdLoaderCreditsContainer .background-info .source { bottom: 8px; left: 0; box-sizing: border-box; opacity: 0; overflow: hidden; transition-delay: 0s; -webkit-transform: translateY(0.7em); position: absolute;}' +
			'.sortdLoaderCreditsContainer .background-info .source a.source-url { color: #ffffff;}' +
			'.sortdLoaderCreditsContainer .background-info:hover .source { -webkit-transform: translateY(0); transition-delay: 0.15s; opacity: 1; }'+
			'.sortdLoaderCreditsContainer .background-info:hover .title { -webkit-transform: translateY(-0.5em); transition-delay: 0s; opacity: 0;}'
	};
	_constants.loader.fullscreenLoaderHtml = '<div id="sortdLoader">' +
			'<div class="sortdLoaderProgress">' +
				'<div><img alt="" src="LOADER_PROGRESS_BAR_URL"></div>' +
				'<br><br>loading USER_EMAIL_ADDRESS' +
			'</div>' +
			_constants.loader.loaderMenuHtml +
			_constants.loader.sortdLoaderCreditsHtml +
		'</div>';
	_constants.loader.fullscreenLoaderCSS = 'body {overflow:hidden} #loading { display: block !important; }' +
		'#sortdLoader {font-family: arial, sans-serif;font-size: 12px;color: #ffffff; position:absolute; top:0; left:0; bottom:0; right:0; z-index: 2000;background-color:#2b2b2b;background-size: 100% 100%;background-image:url(SORTD_LOADER_BACKGROUND_URL);}' +
		'#sortdLoader .sortdLoaderProgress {position: absolute;width: 310px;height: 20px;top: 50%;left: 50%;font-size: 14px;transform: translate(-50%, -100%);-webkit-transform: translate(-50%, -100%);background-image: url(SORTD_LOADER_LOGO_URL);background-repeat: no-repeat;background-position: center top;padding-top: 70px; text-shadow: 0 0 7px rgba(0, 0, 0, 1);}' +
		'#sortdLoader .sortdLoaderProgress > div {display: inline-block;background-color: #efefef;padding: 2px 2px;vertical-align: middle;font-size: 0; border: 1px solid #cecece}';

	_constants.loader.ImagesBackgroundInfos = {
		1: {
			title: 'Arenal Volcano, Costa Rica',
			sourceAuthor: 'Sorin Vacaru',
			sourceLink: 'https://500px.com/photo/69331205/arenal-volcano-sunset-by-sorin-vacaru'
		},
		2: {
			title: 'Barensee, Germany',
			sourceAuthor: 'Wolfgang Simm',
			sourceLink: 'https://500px.com/photo/13412145/lake-on-fire-by-wolfgang-simm'
		},
		3: {
			title: 'Sun rays',
			sourceAuthor: 'Arundevaraj',
			sourceLink: 'https://500px.com/photo/60633590/sun-rays-by-arundevaraj'
		},
		4: {
			title: 'Trondheim, Norway',
			sourceAuthor: 'Hessam M. Nik',
			sourceLink: 'https://500px.com/photo/93543091/let-it-snow-by-hessam-m-nik'
		},
		5: {
			title: 'Amazon River, Peru',
			sourceAuthor: 'Annabelle Avril',
			sourceLink: 'https://500px.com/photo/69331205/arenal-volcano-sunset-by-sorin-vacaru'
		},
		6: {
			title: 'Penang, Malaysia',
			sourceAuthor: 'Kevinellie Photography',
			sourceLink: 'https://500px.com/photo/56062412/sunrise-at-tan-jetty-by-kevinellie-photography'
		},
		7: {
			title: 'Geneva, NY',
			sourceAuthor: 'Daniel Bell',
			sourceLink: 'https://500px.com/photo/67524941/johnson-road-by-daniel-bell'
		}
	};

	/**
	 * Storage keys
	 */
	_constants.STORAGE = {
		EMAIL_PLACEHOLDER: '__EMAIL_ADDRESS__',
		KEYS: {
			DOM_MAP: 'sortd/extension/dommap',
			BUILD_NO: 'sortd/extension/buildno',
			EMAIL: 'sortd/session/email',
			REGISTERED_EMAILS: 'registeredEmails'
		}
	};

	_constants.STORAGE.KEYS.FULLSCREEN = 'sortd/' + _constants.STORAGE.EMAIL_PLACEHOLDER + '/fullscreen';
	_constants.STORAGE.KEYS.FULLSCREEN_OVERRIDE = 'sortd/' + _constants.STORAGE.EMAIL_PLACEHOLDER + '/fullscreenoverride';
	_constants.STORAGE.KEYS.LOADINGINGMAIL = 'sortd/' + _constants.STORAGE.EMAIL_PLACEHOLDER + '/loadingingmail';
	_constants.STORAGE.KEYS.FEATURE_FLAGS = 'sortd/' + _constants.STORAGE.EMAIL_PLACEHOLDER + '/featureflags';
	_constants.STORAGE.KEYS.IS_TRACKED = 'sortd/' + _constants.STORAGE.EMAIL_PLACEHOLDER + '/istracked';
	_constants.STORAGE.KEYS.GMAIL_UI_MODE = 'sortd/' + _constants.STORAGE.EMAIL_PLACEHOLDER + '/gmailuimode';
	_constants.STORAGE.KEYS.GMAIL_DATA_LAYER = 'sortd/' + _constants.STORAGE.EMAIL_PLACEHOLDER + '/gmaildatalayer';

	/**
	 * User settings keys
	 */
	_constants.USER_SETTING_KEYS = {};
	_constants.USER_SETTING_KEYS.LOAD_FULLSCREEN = 'loadFullscreen';
	_constants.USER_SETTING_KEYS.FEATURE_FLAGS = 'featureFlags';
	_constants.USER_SETTING_KEYS.READ_RECEIPTS = 'readReceipts';
	_constants.USER_SETTING_KEYS.GMAIL_MODE_PREVIEW_BAR = 'gmailModePreviewBar';
	_constants.USER_SETTING_KEYS.DEBUG_MODE = 'debugMode';

	/**
	 * Tracker constants
	 */
	_constants.TRACKER = {
		EVENTS: {
			// Category: UserAction
			INSTALLED_EXTENSION: { event: 'Access - Installed Extension', trackOnce: true },
			OPENED_EMAIL_TRACKING_STREAM: { event: 'Email - Opened Email Tracking Stream', trackOnce: false }
		},
		EVENT_ORIGINS: {
			COMPOSE_FROM_TASK: 'Compose mail from task',
			SEND_BUTTON_MENU: 'SendButtonMenu',
			SEND_CONFIRMATION: 'SendConfirmation',
			PREVIEW_BAR: 'PreviewBar',
			PIN_TO_SORTD: 'PinToSortd',
			GMAIL_TOOLBAR: 'Gmail Toolbar',
			GMAIL_THREAD_ROW: 'Gmail Thread Row',
			MARK_AS_UNREAD: 'Gmail Mark as unread',
			MARK_AS_STAR: 'Gmail Star',
			COMPLETE_AND_ARCHIVE: 'Gmail Complete & Archive'
		}
	};

	_constants.ERROR_MESSAGE = {
		EXTENSION_ERROR: 'Logging chrome extension error to the server.'
	};

	_constants.LOG = {
		TYPE: {
			ERROR: 'error',
			WARN: 'warn',
			INFO: 'info'
		}
	};

	_constants.DATE_OVERRIDES = {
		MARK_AS_UNREAD: 'markAsUnread',
		MARK_AS_STAR: 'markAsStar'
	}

	_constants.DATE_ID = {
		TODAY: 0,
		TOMORROW: 1,
		NEXT_WEEK: 2,
		IN_A_MONTH: 3,
		SOME_DAY: 4,
		CUSTOM: 5,
		IN_TWO_DAYS: 6,
		ALL_UPCOMING: 22,
		YESTERDAY: 30,
		ALL_OVERDUE: 33
	};

	_constants.DATE_LABELS = {};
	_constants.DATE_LABELS[_constants.DATE_ID.TODAY] = 'Today';
	_constants.DATE_LABELS[_constants.DATE_ID.TOMORROW] = 'Tomorrow';
	_constants.DATE_LABELS[_constants.DATE_ID.IN_TWO_DAYS] = 'In two days';
	_constants.DATE_LABELS[_constants.DATE_ID.NEXT_WEEK] = 'Next week';
	_constants.DATE_LABELS[_constants.DATE_ID.IN_A_MONTH] = 'In a month';
	_constants.DATE_LABELS[_constants.DATE_ID.SOME_DAY] = 'Some day';
	_constants.DATE_LABELS[_constants.DATE_ID.CUSTOM] = 'Custom';
	_constants.DATE_LABELS[_constants.DATE_ID.YESTERDAY] = 'Yesterday';
	_constants.DATE_LABELS[_constants.DATE_ID.ALL_UPCOMING] = 'Upcoming';
	_constants.DATE_LABELS[_constants.DATE_ID.ALL_OVERDUE] = 'Past';

	_constants.TIME_LABELS = [];
	_constants.TIME_LABELS[_constants.DATE_ID.TODAY] = 'Later today';
	_constants.TIME_LABELS[_constants.DATE_ID.TOMORROW] = 'Tomorrow';
	_constants.TIME_LABELS[_constants.DATE_ID.IN_TWO_DAYS] = 'In two days';
	_constants.TIME_LABELS[_constants.DATE_ID.NEXT_WEEK] = 'Next week';
	_constants.TIME_LABELS[_constants.DATE_ID.IN_A_MONTH] = 'In a month';
	_constants.TIME_LABELS[_constants.DATE_ID.SOME_DAY] = 'Some day';
	_constants.TIME_LABELS[_constants.DATE_ID.CUSTOM] = 'Custom';

	_constants.DATE_PLAN_DATE_IDS = [
		_constants.DATE_ID.TODAY,
		_constants.DATE_ID.TOMORROW,
		_constants.DATE_ID.IN_TWO_DAYS,
		_constants.DATE_ID.NEXT_WEEK,
		_constants.DATE_ID.CUSTOM
	];

	_constants.REMINDER_DATE_IDS = [
		_constants.DATE_ID.TODAY,
		_constants.DATE_ID.TOMORROW,
		_constants.DATE_ID.IN_TWO_DAYS,
		_constants.DATE_ID.NEXT_WEEK,
		_constants.DATE_ID.CUSTOM
	];

	_constants.FILTER_DATE_RANGES = [
		{ dateId: _constants.DATE_ID.TODAY, mapKey: 'today' },
		{ dateId: _constants.DATE_ID.ALL_UPCOMING, mapKey: 'upcoming' },
		{ dateId: _constants.DATE_ID.ALL_OVERDUE, mapKey: 'past' }
	];

	_constants.items = {
		CONTENT_TYPES: {
			EMAIL: 'email',
			TASK: 'task',
			EMAIL_THREAD: 'emailthread',
			SALE: 'sale'
		}
	};	

	_constants.HTML = {};
	_constants.HTML.REMINDER_OPTIONS = '<ul >';
	for (var i = 0; i < 5; i++) {
		_constants.HTML.REMINDER_OPTIONS += '<li reminder="' + i + '" >' + _constants.TIME_LABELS[i] + '</li>';
	}
	_constants.HTML.REMINDER_OPTIONS += '<li reminder="datepicker">Custom</li></ul>';

	_constants.HTML.OPTIONS_CONTAINER_LEFT = '<div class="sortdTimeOptions">';
	_constants.HTML.OPTIONS_CONTAINER_RIGHT = '</div';
	_constants.HTML.REMINDER_OPTIONS = _constants.HTML.OPTIONS_CONTAINER_LEFT + '<div class="heading">Sortd Remind Me</div>' + _constants.HTML.REMINDER_OPTIONS + _constants.HTML.OPTIONS_CONTAINER_RIGHT;
	_constants.HTML.PIN_OPTIONS = _constants.HTML.OPTIONS_CONTAINER_LEFT + '<div  class="heading">Add to</div><ul class="sortdBoardMenu">{LIST_OPTIONS}</ul>' +
		'<div class="sortTip">' +
			'<span class="sortTipDefault">Switch to a different organisation <img alt="" src="TOOL_TIP_ICON_URL"></span>' +
			'<span class="sortTipHover">Open Sortd full screen and use the switcher to select a different Organization</span>' +
		'</div>' + _constants.HTML.OPTIONS_CONTAINER_RIGHT;
	
	_constants.HTML.SORTD_MENU = '<div class="sortdMenu">' +
		'<ul>' +
			'<li id="sortdMenuFS">Open fullscreen</li>' +
			'<li id="sortdMenuBoard">Open board</li>' +
			'<li id="sortdMenuSettings">Settings</li>' +
			'<li id="sortdMenuSupport">Support / FAQ</li>' +
		'</ul>' +
		'<div class="footer">' +
			'<div class="sd_inlblock">New to Sortd, learn more:</div>' +
			'<div class="sd_inlblock"><button class="sortdButton primary" id="sortdMenuWebsite">Sortd website</button></div>' +
		'</div>' +
		'</div>';
	
	_constants.NOTIFICATION_MESSAGES = {
		USER_NOT_LOGGED_IN: 'To use this feature you need to<br/> be signed into Sortd.  <a id="not-loggedin-notification-signin" href="#">Sign in<a/>'
	};

	_constants.HTML.USER_NOT_LOGGED_IN = _constants.HTML.OPTIONS_CONTAINER_LEFT + '<div class="not-logged-in">' + _constants.NOTIFICATION_MESSAGES.USER_NOT_LOGGED_IN + '</div>' + _constants.HTML.OPTIONS_CONTAINER_RIGHT;
	_constants.HTML.READ_RECEIPT = '<div name="sortd_readrcpt" style="max-width:0;max-height:0;overflow:hidden">' +
		'<img alt="" style="width:0;max-height:0;overflow:hidden;" src="READ_RECEIPT_URL"></div>';

	_constants.SORTD_APP_LINKS = {
		VIEW_TASK: {	// legacy view task, changed to VIEW_TASK_NTYPE
			OPEN_SORTD: true,
			ACTIVE_IN_FULLSCREEN: false,
			ACTION: 'viewTask',
			URL_REGEX: /(.*)\/link\/task\/view\/(.*)\/\?d=(.*?)?&u=(.*?)$/,
			PARAM_NAMES: ['taskId', 'dashboardId', 'userId']
		},
		VIEW_TASK_NTYPE: {
			OPEN_SORTD: true,
			ACTIVE_IN_FULLSCREEN: false,
			ACTION: 'viewTask',
			URL_REGEX: /(.*)\/link\/task\/viewnt\/(.*)\/\?d=(.*?)?&u=(.*?)?&t=(.*?)$/,
			PARAM_NAMES: ['taskId', 'dashboardId', 'userId', 'notificationType']
		},
		VIEW_SETTINGS: {
			OPEN_SORTD: true,
			ACTIVE_IN_FULLSCREEN: true,
			ACTION: 'openUserSettings',
			URL_REGEX: /(.*)\/link\/settings\/view$/,
			PARAM_NAMES: []
		},
		VIEW_ORGANISATION_SETTINGS: {
			OPEN_SORTD: true,
			ACTIVE_IN_FULLSCREEN: true,
			ACTION: 'openOrganisationSettings',
			URL_REGEX: /(.*)\/link\/orgsettings\/view$/,
			PARAM_NAMES: []
		}
	};

	_constants.TRACKING_SOURCE = {
		DEFAULT: 'Chrome Web Store',
		CHROME_WEB_STORE: 'Chrome Web Store',
		WEBSITE: 'Sortd Website',
		OTHER: 'Unknown'
	};

	// Matches constants.BOARD_TYPE on the server
	_constants.BOARD_TYPE = {
		PRIVATE: 'private',	// Single user
		SHARED: 'shared',	// Two or more users
		SALES: 'sales'
	};

	// Matches constants.TASK_WORKFLOW_STATUS on the client
	_constants.TASK_WORKFLOW_STATUS = {
		CREATED: 0,
		STARTED: -10000,
		OPEN: -10001,
		COMPLETED: -20000,
		WON: -20001,
		LOST: -20002,
		ABANDONED: -20003
	};

	_constants.TASK_REMINDER = {
		NOTIFICATION_TYPES: {
			EMAIL: 'email',
			POPUP: 'popup'
		},
		RESOURCE_TYPES: {
			USER: 'user',
			ASIGNEE: 'asignee',
			DASHBOARD: 'dashboard'
		}
	};

	return _constants;
})();
