/**
 * Sortd
 * Copyright (c) 2019, Sortd Inc
 * https://www.sortd.com
 *
 * @fileoverview User related functionality
 * @name user
 */

class GmailApiUser {

    constructor(options) {

        this.__FILE_NAME = 'user.js';

        this.config = options.config;
        this.errorHandler = options.errorHandler;
        this.inboxSDK_ = null;
    }

    set inboxSDK(sdk) {
        this.inboxSDK_ = sdk;
    }

    /**
     * Get the user's email address
     * @return {Promise<string>} - Promise with the users email address
     */
    getEmailAddress() {

		return new Promise((resolve) => {

			SortdCommon
				.waitForResult(() => this.inboxSDK_)
				.take(1)
				.onValue((sdk) => {
					resolve(sdk.User.getEmailAddress());
				});
		});
    }
}