/**
 * Sortd
 * Copyright (c) 2019, Sortd Inc
 * https://www.sortd.com
 *
 * @fileoverview Defines the ObjectId class
 * @name ObjectId
 */

var ObjectId = (function () {

	var ObjectId = {
		_counter: Math.floor(Math.random() * (16777216)),
		_processId: Math.floor(Math.random() * (65536)),
		_machineId: null,

		machineId: null,
		processId: null,
		counter: null,
		generate: null
	};

	ObjectId.machineId = function() {

		if (!ObjectId._machineId) {
			ObjectId._machineId = Math.floor(parseInt(localStorage.getItem('machineId'), 10));
		}

		if (!ObjectId._machineId) {
			ObjectId._machineId = Math.floor(Math.random() * (16777216));
			localStorage.setItem('machineId', ObjectId._machineId.toString());
		}

		return ObjectId._machineId.toString(16);
	};

	ObjectId.processId = function() {
		return ObjectId._processId.toString(16);
	};

	ObjectId.counter = function() {

		ObjectId._counter++;
		if (ObjectId._counter > 0xffffff) {
			ObjectId._counter = 0;
		}

		return ObjectId._counter.toString(16);
	};

	ObjectId.generate = function() {

		let timestamp = Math.floor(new Date().getTime() / 1000).toString(16);
		let machineId = ObjectId.machineId();
		let processId = ObjectId.processId();
		let counter = ObjectId.counter();

		return '00000000'.substr(0, 8 - timestamp.length) + timestamp +
			'000000'.substr(0, 6 - machineId.length) + machineId +
			'0000'.substr(0, 4 - processId.length) + processId +
			'000000'.substr(0, 6 - counter.length) + counter;
	};

	return ObjectId;
}());
